// IOEditView.cpp : implementation of the CIOEditView class
//

#include "stdafx.h"
#include "IOEdit.h"

#include "IOEditDoc.h"
#include "IOEditView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CIOEditView

IMPLEMENT_DYNCREATE(CIOEditView, CEditView)

BEGIN_MESSAGE_MAP(CIOEditView, CEditView)
	//{{AFX_MSG_MAP(CIOEditView)
	ON_COMMAND(ID_VIEW_EDITWINDOW, OnViewEditwindow)
	ON_UPDATE_COMMAND_UI(ID_VIEW_EDITWINDOW, OnUpdateViewEditwindow)
	ON_WM_KEYDOWN()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CEditView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CEditView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIOEditView construction/destruction

CIOEditView::CIOEditView()
{
	// TODO: add construction code here
	m_Edit = FALSE;						// Edit dialog box status
	m_bInsert = TRUE;					// Insert mode
}

CIOEditView::~CIOEditView()
{
//	m_fontView.DeleteObject();
}

BOOL CIOEditView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	BOOL bPreCreated = CEditView::PreCreateWindow(cs);
	cs.style &= ~(ES_AUTOHSCROLL|WS_HSCROLL);	// Enable word-wrapping

	return bPreCreated;
}

/////////////////////////////////////////////////////////////////////////////
// CIOEditView drawing

void CIOEditView::OnDraw(CDC* pDC)
{
	CIOEditDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CIOEditView printing

BOOL CIOEditView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default CEditView preparation
	return CEditView::OnPreparePrinting(pInfo);
}

void CIOEditView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView begin printing.
	CEditView::OnBeginPrinting(pDC, pInfo);
}

void CIOEditView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// Default CEditView end printing
	CEditView::OnEndPrinting(pDC, pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CIOEditView diagnostics

#ifdef _DEBUG
void CIOEditView::AssertValid() const
{
	CEditView::AssertValid();
}

void CIOEditView::Dump(CDumpContext& dc) const
{
	CEditView::Dump(dc);
}

CIOEditDoc* CIOEditView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CIOEditDoc)));
	return (CIOEditDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CIOEditView message handlers

#include "EditDlg.h"

void CIOEditView::OnViewEditwindow() 
{
	// TODO: Add your command handler code here
	// Sets dialog box status
	m_Edit = TRUE;
	// Opens and displays edit dialog box
	CEditDlg D;
	D.DoModal();
	// Resets dialog box status
	m_Edit = FALSE;
	// Sets caret
	UpdateCaret(&GetEditCtrl(), m_bInsert);
}

void CIOEditView::OnUpdateViewEditwindow(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	// Enable and check the button when edit dialog is opened
	// Resets when the dialog box is closed
	pCmdUI->SetCheck(m_Edit);
	pCmdUI->Enable(m_Edit == FALSE);
}

void CIOEditView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	// TODO: Add your message handler code here and/or call default
	if (nChar == VK_INSERT)				// Insert key handled
		m_bInsert = !m_bInsert;			// Toggles insert key status
	CEditView::OnKeyDown(nChar, nRepCnt, nFlags);
}

BOOL CIOEditView::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	switch (pMsg->message)
	{
	case (WM_KEYDOWN):
	case (WM_KEYUP):
	case (WM_LBUTTONDOWN):
	case (WM_LBUTTONUP):
	case (WM_SETFOCUS):
		{
			UpdateCaret(&GetEditCtrl(), m_bInsert);
			break;
		}
	case (WM_CHAR):
		{
			if (!m_bInsert && pMsg->wParam >= ' ' && pMsg->wParam <= 0xFF)
				DeleteNextChar(&GetEditCtrl());
			break;
		}
	}
	return CEditView::PreTranslateMessage(pMsg);
}
